/* Copyright(C) 2014 Cobac.Net All rights reserved. */
/* p^[\H */

module pattern(
    input                   CLK,
    input                   RST,
    output                  VGA_HS,
    output                  VGA_VS,
    output  reg     [3:0]   VGA_R,
    output  reg     [3:0]   VGA_G,
    output  reg     [3:0]   VGA_B
);

/* VGA(640~480)p[^ */
localparam HSC = 10'd800;
localparam HFP = 10'd16;
localparam HPW = 10'd96;
localparam HBP = 10'd48;

localparam VSC = 10'd525;
localparam VFP = 10'd10;
localparam VPW = 10'd2;
localparam VBP = 10'd33;

localparam HSIZE = 10'd80;
localparam VSIZE = 10'd120;

/* MH̐ڑ */
wire            PCK;
wire    [9:0]   HCNT, VCNT;

syncgen syncgen(
    .CLK    (CLK),
    .RST    (RST),
    .PCK    (PCK),
    .VGA_HS (VGA_HS),
    .VGA_VS (VGA_VS),
    .HCNT   (HCNT),
    .VCNT   (VCNT)
);

/* RGBo͂쐬 */
wire disp_enable = (HFP+HPW+HBP-10'd1 <= HCNT) && (HCNT < HSC-10'd1)
                && (VFP+VPW+VBP <= VCNT);
wire [2:0] rgb_0 = (HCNT-HFP-HPW-HBP+10'd1)/HSIZE;
wire [2:0] rgb_1 = (((VCNT-VFP-VPW-VBP)/VSIZE)&1)==0 ? 3'd7-rgb_0: rgb_0;

always @( posedge PCK ) begin
    if ( RST )
        {VGA_R, VGA_G, VGA_B} <= 12'h000;
    else if ( disp_enable )
        {VGA_R, VGA_G, VGA_B} <= { {4{rgb_1[2]}}, {4{rgb_1[1]}}, {4{rgb_1[0]}} };
    else
        {VGA_R, VGA_G, VGA_B} <= 12'h0;
end

endmodule
